
#ifndef INCLUDE_DRIVER_DTV_H
#define INCLUDE_DRIVER_DTV_H


#define DTVIOCSIUNIT  _IOW('D', 0x01, int)
#define DTVIOCGIUNIT  _IOR('D', 0x02, int*)

#if 0  /* EM1 DTV supports only serial transmission.  */
/* DTVIOCSINPUT/DTVIOCGINPUT */
#define DTVIOCSINPUT  _IOW('D', 0x03, int)
#define DTVIOCGINPUT  _IOR('D', 0x04, int*)
#define DTV_INPUT_PARALLEL 0x0 /* default */
#define DTV_INPUT_SERIAL   0x1
#endif

/* DTVIOCSPKTSZ/DTVIOCGPKTSZ */
#define DTVIOCSPKTSZ  _IOW('D', 0x05, int)
#define DTVIOCGPKTSZ  _IOR('D', 0x06, int*)
#define DTV_PKTSZ_188      0x0 /* default */
#define DTV_PKTSZ_204      0x1


/* DTVIOCSPKTFMT/DTVIOCGPKTFMT */
#define DTVIOCSPKTFMT _IOW('D', 0x07, int)
#define DTVIOCGPKTFMT _IOR('D', 0x08, int*)
#define DTV_PKTFMT_BIG     0x0
#define DTV_PKTFMT_LITTLE  0x1 /* default */


#define DTVIOCSSTART  _IO('D', 0x10)
#define DTVIOCSSTOP   _IO('D', 0x11)
#define DTVIOCSRESET  _IO('D', 0x12)
#define DTVIOCGCOND   _IOR('D', 0x20, int*)


/* select DTV module */
#define DTVIOCSMODULE _IOW('D', 0x09, int)
#define DTVIOCGMODULE _IOR('D', 0x0a, int*)

#define DTV_MODULE_DTV1 0	/* use DTV1 */
#define DTV_MODULE_DTV2 1	/* use DTV2 */


/* set signal polarity */
#define DTVIOCSVLDPOL   _IOW('D', 0x0b, int)
#define DTVIOCGVLDPOL   _IOR('D', 0x0c, int*)
#define DTVIOCSPSYNCPOL _IOW('D', 0x0d, int)
#define DTVIOCGPSYNCPOL _IOR('D', 0x0e, int*)

#define DTV_POL_NORMAL 0	/* signal normal */
#define DTV_POL_REVERS 1	/* signal reversal */


#endif	/* INCLUDE_DRIVER_DTV_H */
