/*
 *  File Name       : linux/include/asm-arm/arch-mp200/extio.h
 *  Function        : External GPIO
 *  Release Version : Ver 1.00
 *  Release Date    : 2009/06/11
 *
 *  Copyright (C) NEC Electronics Corporation 2009
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#ifndef _ASM_ARCH_EXTIO_H_
#define _ASM_ARCH_EXTIO_H_

/* GPIO Output/Input select */
#define EXTIO_IN	0
#define EXTIO_OUT	1

extern int mp200_extio_initialized;

extern int extio_reg_read(int addr, unsigned char *data);
extern int extio_reg_write(int addr, unsigned char data);
extern int extio_read(int addr, unsigned char *data);
extern int extio_write(int addr, unsigned char data, unsigned char mask);
extern int extio_set_direction(unsigned gpio, int is_input);
extern int extio_get_value(unsigned int gpio);
extern void extio_set_value(unsigned int gpio, int value);

#endif /* _ASM_ARCH_EXTIO_H_ */
