/*
 *  File Name       : linux/include/asm-arm/arch-mp200/pwc.h
 *  Function        : pwc
 *  Release Version : Ver 1.00
 *  Release Date    : 2007/06/25
 *
 *  Copyright (C) NEC Electronics Corporation 2007
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */
#ifndef _ASM_ARCH_PWC_H_
#define _ASM_ARCH_PWC_H_

/* Power register */
#ifdef CONFIG_MP200_EM1_DKIT

/* System control and event registers */
#define DA9052_PAGECON0_REG		(0)	/* read/write */
#define DA9052_STATUSA_REG		(1)	/* read */
#define DA9052_STATUSB_REG		(2)	/* read */
#define DA9052_STATUSC_REG		(3)	/* read */
#define DA9052_STATUSD_REG		(4)	/* read */
#define DA9052_EVENTA_REG		(5)	/* read */
#define DA9052_EVENTB_REG		(6)	/* read */
#define DA9052_EVENTC_REG		(7)	/* read */
#define DA9052_EVENTD_REG		(8)	/* read */
#define DA9052_FAULTLOG_REG		(9)	/* read */
#define DA9052_IRQMASKA_REG		(10)	/* read/write */
#define DA9052_IRQMASKB_REG		(11)	/* read/write */
#define DA9052_IRQMASKC_REG		(12)	/* read/write */
#define DA9052_IRQMASKD_REG		(13)	/* read/write */
#define DA9052_CONTROLA_REG		(14)	/* read/write */
#define DA9052_CONTROLB_REG		(15)	/* read/write */
#define DA9052_CONTROLC_REG		(16)	/* read/write */
#define DA9052_CONTROLD_REG		(17)	/* read/write */
#define DA9052_PDDIS_REG		(18)	/* read/write */
#define DA9052_INTERFACE_REG	(19)	/* read */
#define DA9052_RESET_REG		(20)	/* read/write */

/* GPIO control registers */
#define DA9052_GPIO0001_REG		(21)	/* read/write */
#define DA9052_GPIO0203_REG		(22)	/* read/write */
#define DA9052_GPIO0405_REG		(23)	/* read/write */
#define DA9052_GPIO0607_REG		(24)	/* read/write */
#define DA9052_GPIO0809_REG		(25)	/* read/write */
#define DA9052_GPIO1011_REG		(26)	/* read/write */
#define DA9052_GPIO1213_REG		(27)	/* read/write */
#define DA9052_GPIO1415_REG		(28)	/* read/write bit3 read only */

/* Power sequencer control registers */
#define DA9052_ID01_REG			(29)	/* read/write */
#define DA9052_ID23_REG			(30)	/* read/write */
#define DA9052_ID45_REG			(31)	/* read/write */
#define DA9052_ID67_REG			(32)	/* read/write */
#define DA9052_ID89_REG			(33)	/* read/write */
#define DA9052_ID1011_REG		(34)	/* read/write */
#define DA9052_ID1213_REG		(35)	/* read/write */
#define DA9052_ID1415_REG		(36)	/* read/write */
#define DA9052_ID1617_REG		(37)	/* read/write */
#define DA9052_ID1819_REG		(38)	/* read/write */
#define DA9052_ID2021_REG		(39)	/* read/write */
#define DA9052_SEQSTATUS_REG	(40)	/* read/write */
#define DA9052_SEQA_REG			(41)	/* read/write */
#define DA9052_SEQB_REG			(42)	/* read/write */
#define DA9052_SEQTIMER_REG		(43)	/* read/write */

/* Power supply control registers */
#define DA9052_BUCKA_REG		(44)	/* read/write */
#define DA9052_BUCKB_REG		(45)	/* read/write */
#define DA9052_BUCKCORE_REG		(46)	/* read/write */
#define DA9052_BUCKPRO_REG		(47)	/* read/write */
#define DA9052_BUCKMEM_REG		(48)	/* read/write */
#define DA9052_BUCKPERI_REG		(49)	/* read/write bit6 read only*/
#define DA9052_LDO1_REG			(50)	/* read/write bit5 read only*/
#define DA9052_LDO2_REG			(51)	/* read/write */
#define DA9052_LDO3_REG			(52)	/* read/write */
#define DA9052_LDO4_REG			(53)	/* read/write */
#define DA9052_LDO5_REG			(54)	/* read/write */
#define DA9052_LDO6_REG			(55)	/* read/write */
#define DA9052_LFO7_REG			(56)	/* read/write */
#define DA9052_LDO8_REG			(57)	/* read/write */
#define DA9052_LDO9_REG			(58)	/* read/write */
#define DA9052_LDO10_REG		(59)	/* read/write */
#define DA9052_SUPPLY_REG		(60)	/* read/write */
#define DA9052_PULLDOWN_REG		(61)	/* read/write */

/* Charging control registers */
#define DA9052_CHGBUCK_REG		(62)	/* read/write */
#define DA9052_WAITCONT_REG		(63)	/* read/write */
#define DA9052_ISET_REG			(64)	/* read/write */
#define DA9052_BATCHG_REG		(65)	/* read/write */
#define DA9052_CHGCONT_REG		(66)	/* read/write */
#define DA9052_INPUTCONT_REG	(67)	/* read */
#define DA9052_CHGTIME_REG		(68)	/* read/write */

/* Backup battery charging control registers */
#define DA9052_BBATCONT_REG		(69)	/* read/write */

/* Boost and LED driver control registers */
#define DA9052_BOOST_REG		(70)	/* read/write bit7 read only*/
#define DA9052_LEDCONT_REG		(71)	/* read/write bit7 read only*/
#define DA9052_LEDMIN123_REG	(72)	/* read/write */
#define DA9052_LED1CONF_REG		(73)	/* read/write */
#define DA9052_LED2CONF_REG		(74)	/* read/write */
#define DA9052_LED3CONF_REG		(75)	/* read/write */
#define DA9052_LED1CONT_REG		(76)	/* read/write */
#define DA9052_LED2CONT_REG		(77)	/* read/write */
#define DA9052_LED3CONT_REG		(78)	/* read/write */
#define DA9052_LED4CONT_REG		(79)	/* read/write */
#define DA9052_LED5CONT_REG		(80)	/* read/write */

/* GP-ADC control registers */
#define DA9052_ADCMAN_REG		(81)	/* read/write bit7-5 read only*/
#define DA9052_ADCCONT_REG		(82)	/* read/write */
#define DA9052_ADCRESL_REG		(83)	/* read */
#define DA9052_ADCRESH_REG		(84)	/* read */
#define DA9052_VDDRES_REG		(85)	/* read */
#define DA9052_VDDMON_REG		(86)	/* read/write */
#define DA9052_ICHGAV_REG		(87)	/* read */
#define DA9052_ICHGTHD_REG		(88)	/* read/write */
#define DA9052_ICHGEND_REG		(89)	/* read/write */
#define DA9052_TBATRES_REG		(90)	/* read */
#define DA9052_TBATHIGHP_REG		(91)	/* read/write */
#define DA9052_TBATHIGHIN_REG		(92)	/* read/write */
#define DA9052_TBATLOW_REG		(93)	/* read/write */
#define DA9052_TOFFSET_REG		(94)	/* read/write */
#define DA9052_ADCIN4RES_REG		(95)	/* read */
#define DA9052_AUTO4HIGH_REG		(96)	/* read/write */
#define DA9052_AUTO4LOW_REG		(97)	/* read/write */
#define DA9052_ADCIN5RES_REG		(98)	/* read */
#define DA9052_AUTO5HIGH_REG		(99)	/* read/write */
#define DA9052_AUTO5LOW_REG		(100)	/* read/write */
#define DA9052_ADCIN6RES_REG		(101)	/* read */
#define DA9052_AUTO6HIGH_REG		(102)	/* read/write */
#define DA9052_AUTO6LOW_REG		(103)	/* read/write */
#define DA9052_TJUNCRES_REG		(104)	/* read */

/* TSI control registers */
#define DA9052_TSICONTA_REG		(105)	/* read/write */
#define DA9052_TSICONTB_REG		(106)	/* read/write */
#define DA9052_TSIXMSB_REG		(107)	/* read */
#define DA9052_TSIYMSB_REG		(108)	/* read */
#define DA9052_TSILSB_REG		(109)	/* read */
#define DA9052_TSIZMSB_REG		(110)	/* read */

/* RTC calendar and alarm */
#define DA9052_COUNTS_REG		(111)	/* read/write bit7 read only*/
#define DA9052_COUNTMI_REG		(112)	/* read/write bit7-6 read only*/
#define DA9052_COUNTH_REG		(113)	/* read/write bit7-5 read only*/
#define DA9052_COUNTD_REG		(114)	/* read/write bit7-5 read only*/
#define DA9052_COUNTMO_REG		(115)	/* read/write bit7-4 read only*/
#define DA9052_COUNTY_REG		(116)	/* read/write */
#define DA9052_ALARMMI_REG		(117)	/* read/write */
#define DA9052_ALARMH_REG		(118)	/* read/write bit7-5 read only */
#define DA9052_ALARMD_REG		(119)	/* read/write bit7-5 read only */
#define DA9052_ALARMMO_REG		(120)	/* read/write bit7-4 read only */
#define DA9052_ALARMY_REG		(121)	/* read/write */
#define DA9052_SECONDA_REG		(122)	/* read */
#define DA9052_SECONDB_REG		(123)	/* read */
#define DA9052_SECONDC_REG		(124)	/* read */
#define DA9052_SECONDD_REG		(125)	/* read */

#if 0
/* Customer OTP */
#define DA9052_PAGECON128_REG		(128)	/* read/write */
#define DA9052_CHIPID_REG		(129)	/* read */
#define DA9052_CONFIGID_REG		(130)	/* read */
#define DA9052_OTPCONT_REG		(131)	/* read/write bit5-4 read only */
#define DA9052_OSCTRIM_REG		(132)	/* read/write */
#define DA9052_GPID0_REG		(133)	/* read/write */
#define DA9052_GPID1_REG		(134)	/* read/write */
#define DA9052_GPID2_REG		(135)	/* read/write */
#define DA9052_GPID3_REG		(136)	/* read/write */
#define DA9052_GPID4_REG		(137)	/* read/write */
#define DA9052_GPID5_REG		(138)	/* read/write */
#define DA9052_GPID6_REG		(139)	/* read/write */
#define DA9052_GPID7_REG		(140)	/* read/write */
#define DA9052_GPID8_REG		(141)	/* read/write */
#define DA9052_GPID9_REG		(142)	/* read/write */

#define DA9052_PAGE1_REG_START	(DA9052_CHIPID_REG)
#define DA9052_PAGE1_REG_END	(DA9052_GPID9_REG)
#endif

#define DA9052_PAGE0_REG_START	(DA9052_STATUSA_REG)
#define DA9052_PAGE0_REG_END	(DA9052_SECONDD_REG)

#define PWC_MAX			125


#else /* CONFIG_MP200_EM1_DKIT */

#define PWC_REGA		0x0002	/* write */
#define PWC_PSCNT1		0x0004	/* write */
#define PWC_PSCNT2		0x0006	/* write */
#define PWC_MODESET1	0x0008	/* write */
#define PWC_VOUTSET1	0x000A	/* write */
#define PWC_VOUTSET2	0x000C	/* write */
#define PWC_VOUTSET3	0x000E	/* write */

/* GPIO register */
#define PWC_IOSEL1		0x0010	/* write */
#define PWC_IOSEL2		0x0012	/* write */
#define PWC_IOOUT1		0x0014	/* write */
#define PWC_IOIN1		0x0015	/* read  */
#define PWC_IOOUT2		0x0016	/* write */
#define PWC_IOIN2		0x0017	/* read  */
#define PWC_GPPUPD1		0x0018	/* write */
#define PWC_GPPUPD2		0x001A	/* write */
#define PWC_GPPUPD3		0x001C	/* write */
#define PWC_GPPUPD4		0x001E	/* write */

/* INTC register */
#define PWC_FMASK1		0x0020	/* write */
#define PWC_FACTOR1		0x0021	/* read  */
#define PWC_FMASK2		0x0022	/* write */
#define PWC_FACTOR2		0x0023	/* read  */
#define PWC_FMASK3		0x0024	/* write */
#define PWC_FACTOR3		0x0025	/* read  */
#define PWC_STATE1		0x0026	/* write */
#define PWC_STATE2		0x0028	/* write */
#define PWC_STATE3		0x002A	/* write */
#define PWC_CLRFACT1	0x002C	/* write */
#define PWC_CLRFACT2	0x002E	/* write */
#define PWC_CLRFACT3	0x0030	/* write */
#define PWC_DETMOD1L	0x0032	/* write */
#define PWC_DETMOD1H	0x0034	/* write */
#define PWC_DETMOD2L	0x0036	/* write */
#define PWC_DETMOD2H	0x0038	/* write */
#define PWC_DETMOD3L	0x003A	/* write */
#define PWC_DETMOD3H	0x003C	/* write */
#define PWC_BMASK1		0x003E	/* write */
#define PWC_BMASK2		0x0040	/* write */
#define PWC_BMASK3		0x0042	/* write */
#define PWC_REGPWONMSK	0x004C	/* write */
#define PWC_WRSTFCT		0x006D	/* read  */
#define PWC_WRSTCL		0x006E	/* write */
#define PWC_WRSTMSK		0x0092	/* write */
#define PWC_WAKECONT	0x0094	/* write */

/* Power switch register */
#define PWC_PSW_STATE	0x0065	/* read  */

/* ADC register */
#define PWC_ADDATA1		0x004D	/* read  */
#define PWC_ADMODE		0x004E	/* write */
#define PWC_ADDATA2		0x004F	/* read  */
#define PWC_VCCVBATSW	0x0050	/* write */
#define PWC_ADDATA3		0x0051	/* read  */
#define PWC_VCCADPSW	0x0052	/* write */
#define PWC_VCCVBUSSW	0x0052	/* write */
#define PWC_ADDATA4		0x0053	/* read  */
#define PWC_ADDATA5		0x0055	/* read  */
#define PWC_ADDATA6		0x0057	/* read  */
#define PWC_ADDATA7		0x0059	/* read  */
#define PWC_ADDATA8		0x005B	/* read  */

/* Charge register */
#define PWC_CHGCNTR1	0x005C	/* write */
#define PWC_CHGIRR		0x005D	/* read  */
#define PWC_CHGIRCL		0x005E	/* write */
#define PWC_CHGSTATE	0x005F	/* read  */
#define PWC_TIMCNTR		0x0060	/* write */
#define PWC_CVSETR		0x0062	/* write */
#define PWC_CHGCNTR2	0x0064	/* write */

/* Reset register */
#define PWC_SFTRST		0x0066	/* write */
#define PWC_RDET_EN		0x0068	/* write */
#define PWC_PWRSWCONT	0x006A	/* write */
#define PWC_DETIOCONT	0x006C	/* write */

/* LSI discrimination register */
#define PWC_LSIVER		0x006F	/* read  */

/* RTC register */
#define PWC_SEC			0x0070	/* write */
#define PWC_SEC_RD		0x0071	/* read  */
#define PWC_MIN			0x0072	/* write */
#define PWC_MIN_RD		0x0073	/* read  */
#define PWC_HOUR		0x0074	/* write */
#define PWC_HOUR_RD		0x0075	/* read  */
#define PWC_WEEK		0x0076	/* write */
#define PWC_WEEK_RD		0x0077	/* read  */
#define PWC_DAY			0x0078	/* write */
#define PWC_DAY_RD		0x0079	/* read  */
#define PWC_MONTH		0x007A	/* write */
#define PWC_MONTH_RD	0x007B	/* read  */
#define PWC_YEAR		0x007C	/* write */
#define PWC_YEAR_RD		0x007D	/* read  */
#define PWC_TRIM		0x007E	/* write */
#define PWC_TRIM_RD		0x007F	/* read  */
#define PWC_ALM_WM		0x0080	/* write */
#define PWC_ALM_WM_RD	0x0081	/* read  */
#define PWC_ALM_WH		0x0082	/* write */
#define PWC_ALM_WH_RD	0x0083	/* read  */
#define PWC_ALM_WW		0x0084	/* write */
#define PWC_ALM_WW_RD	0x0085	/* read  */
#define PWC_ALM_DM		0x0086	/* write */
#define PWC_ALM_DM_RD	0x0087	/* read  */
#define PWC_ALM_DH		0x0088	/* write */
#define PWC_ALM_DH_RD	0x0089	/* read  */
#define PWC_RTC1		0x008A	/* write */
#define PWC_RTC1_RD		0x008B	/* read  */
#define PWC_RTC2		0x008C	/* write */
#define PWC_RTC2_RD		0x008D	/* read  */

/* USB register */
#define PWC_USBCONT		0x0090	/* write */

#define PWC_MAX			0x0095

#endif /* CONFIG_MP200_EM1_DKIT */

/* GPIO port */
#define PWC_INT_B0		0x00
#define PWC_INT_B1		0x01
#define PWC_INT_B2		0x02
#define PWC_INT_B3		0x03
#define PWC_INT_B4		0x04
#define PWC_INT_B5		0x05
#define PWC_INT_B6		0x06
#define PWC_INT_B7		0x07
#define PWC_INT_MAX		0x07


/* GPIO Output/Input select */
#define PWC_GPIO_OUTPUT	0
#define PWC_GPIO_INPUT	1

extern int  pwc_reg_read(unsigned char addr, unsigned char *data);
extern int  pwc_reg_write(unsigned char addr, unsigned char data);
extern int  pwc_read(unsigned short offset, unsigned int *data);
extern int  pwc_write(unsigned short offset, unsigned int data, unsigned int mask);
extern int  pwc_set_direction(unsigned gpio, int is_input);
extern int  pwc_get_value(unsigned int gpio);
extern void pwc_set_value(unsigned int gpio, int value);
extern int  pwc_get_output_value(unsigned int gpio);

#endif /* _ASM_ARCH_PWC_H_ */
