/*
 *  File Name       : linux/include/asm-arm/arch-mp200/system.h
 *  Function        : system
 *  Release Version : Ver 1.00
 *  Release Date    : 2005/05/16
 *
 *  Copyright (C) NEC Electronics Corporation 2005
 *
 *
 *  This program is free software;you can redistribute it and/or modify it under the terms of
 *  the GNU General Public License as published by Free Softwere Foundation; either version 2
 *  of License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along with this program;
 *  If not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA 02111-1307, USA.
 *
 */

#ifndef __ASM_ARCH_MP200_SYSTEM_H
#define __ASM_ARCH_MP200_SYSTEM_H

#include <asm/io.h>
#include <asm/proc-fns.h>
#include <mach/pwc.h>

static DEFINE_SPINLOCK(idle_spinlock);

static void arch_idle(void)
{
	unsigned long flags;

	/*
	 * This should do all the clock switching
	 * and wait for interrupt tricks
	 */
	spin_lock_irqsave(&idle_spinlock, flags);
	cpu_do_idle();
	spin_unlock_irqrestore(&idle_spinlock, flags);
}

static inline void arch_reset(char mode)
{
#ifdef	CONFIG_MP200_EM1_DKIT
// eflow-added
	pwc_write(DA9052_IRQMASKA_REG, 0x00, 0x20);	// R10	<5>	M_ALARM		= 0
	pwc_write(DA9052_EVENTA_REG, 0x20, 0x20);	// R5	<5>	E_ALARM		= 0

	pwc_write(DA9052_LDO2_REG, 0x80, 0x80);		// R51	<7>	LDO2_CONF	= 1
	pwc_write(DA9052_RESET_REG, 0x80, 0xc0);	// R20	<7:6>RESET_EVENT= 10(PWR_UP)
	pwc_write(DA9052_WAITCONT_REG, 0x00, 0x40);	// R63	<6>	RTC_CLOCK	= 0
	pwc_write(DA9052_ALARMMI_REG, 0x00, 0x80);	// R117	<5>	TICK_TYPE	= 0
	pwc_write(DA9052_ALARMY_REG, 0x80, 0x80);	// R121	<7>	TICK_ON		= 1
	pwc_write(DA9052_CONTROLB_REG, 0x40, 0x40);	// R15	<6>	DEEP_SLEEP	= 1
// END eflow-added
#else
	pwc_write(PWC_SFTRST, 0xff, 0xff);
#endif
}

#endif	/* __ASM_ARCH_MP200_SYSTEM_H */
