/*
 * Copyright (C) 2000,2001,2004 Broadcom Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
#include <linux/init.h>

#ifdef CONFIG_SIMULATION
#define BCM1480_HPT_VALUE       50000
#else
/* zbbus_mhz is an exported symbol initialized in bcm1480_setup() to that it
 * contains the zbbus frequency in MHz. The zbbus runs as 1/2 the clock
 * frequency. */
extern unsigned int zbbus_mhz;
#define BCM1480_HPT_VALUE	(zbbus_mhz * 2 * 1000000)
#endif

extern unsigned int mips_hpt_frequency;
extern void sb1480_clockevent_init(void);
extern void sb1480_clocksource_init(void);

void __init plat_time_init(void)
{
	sb1480_clocksource_init();
	sb1480_clockevent_init();

	/* To initialize mips_hpt_frequency used by ltt_frequency
	 * otherwise there is div/zero when boot. 
	 */
	mips_hpt_frequency = BCM1480_HPT_VALUE;
}
