/*
 * Copyright (C) 2007,2008 Giuseppe Cavallaro <peppe.cavallaro@st.com>
 *                         Mathieu Desnoyers <mathieu.desnoyers@polymtl.ca>
 *
 * Trace clock definitions for SuperH.
 */

#ifndef _ASM_SH_TRACE_CLOCK_H
#define _ASM_SH_TRACE_CLOCK_H

#include <linux/timer.h>
#include <asm/clock.h>

extern u64 trace_clock_read_synthetic_tsc(void);

static inline u32 trace_clock_get_timestamp32(void)
{
	return get_cycles();
}

static inline u64 trace_clock_get_timestamp64(void)
{
	return trace_clock_read_synthetic_tsc();
}

static inline void trace_clock_add_timestamp(unsigned long ticks)
{ }

static inline unsigned int trace_clock_frequency(void)
{
	unsigned long rate;
	struct clk *tmu1_clk;

	tmu1_clk = clk_get(NULL, "tmu1_clk");
	rate = clk_get_rate(tmu1_clk);

	return (unsigned int)rate;
}

static inline u32 trace_clock_freq_scale(void)
{
	return 1;
}
#endif /* _ASM_SH_TRACE_CLOCK_H */
