/*
 * drivers/misc/mv64460_timer.h
 * programmable marvell timers API.
 *
 * Author:  Majid Khan M Z, (amm117@motorola.com).
 * Copyright 
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 *
 */


#ifndef MV64x60_TIMER_H
#define MV64x60_TIMER_H

typedef void(*mv64x60_timer_f) (void *data);

/* start timer function, func will get called after timer interrupt and its called from interrupt context*/
int mv64x60_timer_start(int timer_number, unsigned long microseconds, mv64x60_timer_f func, void *data, int periodic);

/* stop a timer*/
int mv64x60_timer_stop(int timer_number);

#endif /*MV64x60_TIMER_H*/
