/*
 * File Name       : /drivers/video/mp200/mp200_lcdhw.h
 * Function        : LCD Driver corresponding to V4L2 (H/W Control)
 * Release Version :
 * Release Date    : 2009.10.21
 *
 * Copyright (C) NEC Electronics Corporation 2009
 *
 *
 * This program is free software;you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by Free Softwere
 * Foundation; either version 2 of License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warrnty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; If not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef _MP200_LCDHW_H_
#define _MP200_LCDHW_H_



/********************************************************
 *  Variables                                           *
 *******************************************************/
extern int init_is_first;

/* IMC layer */
extern struct l01_param			fb_layer;
extern struct l2_param			v4l2_layer;
extern struct mp200_imc_update_vsync	ImcNxtVsync;
extern struct imc_keycolor_param	ImcNxtKeycol;
extern struct imc_bytelane_param	ImcNxtBytelane;


/********************************************************
 *  Prototype declarations of function                  *
 *******************************************************/
/* ------------------ LCD control function --------------------------------- */
extern int           change_frame(void);
extern int           init_lcdhw(void);
extern void          exit_lcdhw(void);

/* ------------------ LCD H/W control function ----------------------------- */
extern void          lcd_hw_save_reg(void);
extern void          lcd_hw_restore_reg(void);
extern void          lcd_hw_start(void);
extern void          lcd_hw_stop(void);
extern void          lcd_hw_reset(void);
extern void          lcd_hw_unreset(void);
extern void          lcd_hw_power_off(void);
extern void          lcd_hw_power_on(void);
extern void          lcd_hw_backlight_off(void);
extern void          lcd_hw_backlight_on(void);

/* ------------------ LCDC rgister check function ------------------------- */
extern unsigned long lcd_hw_chk_status(void);
extern unsigned long lcd_hw_chk_bussel(void);
extern unsigned long lcd_hw_chk_int_status(void);
extern unsigned long lcd_hw_chk_int_rawstatus(void);

/* ------------------ LCDC interruput control function --------------------- */
extern void          lcd_hw_int_enable(void);
extern void          lcd_hw_int_disable(void);
extern void          lcd_hw_int_factor_clr(void);

/* ------------------ IMC initialize function ------------------------------ */
extern int           imc_hw_restore_reg(void);

/* ------------------ IMC control function --------------------------------- */
extern int imc_hw_set_update_vsync(struct mp200_imc_update_vsync *vsync);
extern int imc_hw_set_update_keycolor(struct imc_keycolor_param *keycolor);
extern int imc_hw_set_update_bytelane(struct imc_bytelane_param *bytelane);
extern int imc_hw_set_update_reserve(int type, int mixdsp, int update);



#endif /* _MP200_LCDHW_H_ */

