/*
 * Copyright (C) 2005,2008 Mathieu Desnoyers
 *
 * Trace clock MIPS definitions.
 */

#ifndef _ASM_MIPS_TRACE_CLOCK_H
#define _ASM_MIPS_TRACE_CLOCK_H

#include <linux/timex.h>
#include <asm/processor.h>

extern u64 trace_clock_read_synthetic_tsc(void);

/*
 * MIPS get_cycles only returns a 32 bits TSC (see timex.h). The assumption
 * there is that the reschedule is done every 8 seconds or so. Given that
 * tracing needs to detect delays longer than 8 seconds, we need a full 64-bits
 * TSC, whic is provided by trace-clock-32-to-64.
*/
static inline u32 trace_clock_read32(void)
{
	return get_cycles();
}

static inline u64 trace_clock_read64(void)
{
	return trace_clock_read_synthetic_tsc();
}

static inline void trace_clock_add_timestamp(unsigned long ticks)
{ }

static inline unsigned int trace_clock_frequency(void)
{
	return mips_hpt_frequency;
}

static inline u32 trace_clock_freq_scale(void)
{
	return 1;
}

#endif /* _ASM_MIPS_TRACE_CLOCK_H */
